//importing necessary modules from D3 library
import { select, json, geoPath, geoMercator } from 'd3';
//importing feature method from TopoJSON which will create the GeoJSON objects
import { feature } from 'topojson';
const svg = select('svg');//Selecting the SVG element in the HTML
// Creating a new geoMeractor projection centered on China
const projection = geoMercator()
	.center([105, 43])//Centering the projection on China
	.scale([820]);//Setting the scale of the projection
const pathGenerator = geoPath().projection(projection)

/*Defining the URL of the basemap data in TopoJSON format*/
const basemapUrl = 'https://gist.githubusercontent.com/Z-Richard/d1f285c1baf085a7b4f3331fb7dc0e12/raw/9437745ce91c30f7c2e433e3b9ff7adb270e8497/china-city-basemap-topojson.json';
//Fetching the basemap data from the provided URL
json(basemapUrl)
	.then(data => {
  	const countries = feature(data, data.objects.china_city_basemap)
    svg.selectAll('path')
      .data(countries.features)
  		.enter().append('path')
  		.attr('class', 'country')
  		.attr('d', pathGenerator)
  });


